// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct StaticCurvedMesh : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static StaticCurvedMesh GetRootAsStaticCurvedMesh(ByteBuffer _bb) { return GetRootAsStaticCurvedMesh(_bb, new StaticCurvedMesh()); }
  public static StaticCurvedMesh GetRootAsStaticCurvedMesh(ByteBuffer _bb, StaticCurvedMesh obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public StaticCurvedMesh __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public Veneris.Communications.Matrix4x4? Transform { get { int o = __p.__offset(4); return o != 0 ? (Veneris.Communications.Matrix4x4?)(new Veneris.Communications.Matrix4x4()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? Vertices(int j) { int o = __p.__offset(6); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(__p.__vector(o) + j * 12, __p.bb) : null; }
  public int VerticesLength { get { int o = __p.__offset(6); return o != 0 ? __p.__vector_len(o) : 0; } }
  public int Indexes(int j) { int o = __p.__offset(8); return o != 0 ? __p.bb.GetInt(__p.__vector(o) + j * 4) : (int)0; }
  public int IndexesLength { get { int o = __p.__offset(8); return o != 0 ? __p.__vector_len(o) : 0; } }
#if ENABLE_SPAN_T
  public Span<int> GetIndexesBytes() { return __p.__vector_as_span<int>(8, 4); }
#else
  public ArraySegment<byte>? GetIndexesBytes() { return __p.__vector_as_arraysegment(8); }
#endif
  public int[] GetIndexesArray() { return __p.__vector_as_array<int>(8); }
  public Veneris.Communications.MaterialEMP? Material { get { int o = __p.__offset(10); return o != 0 ? (Veneris.Communications.MaterialEMP?)(new Veneris.Communications.MaterialEMP()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec4? Pd1(int j) { int o = __p.__offset(12); return o != 0 ? (Veneris.Communications.Vec4?)(new Veneris.Communications.Vec4()).__assign(__p.__vector(o) + j * 16, __p.bb) : null; }
  public int Pd1Length { get { int o = __p.__offset(12); return o != 0 ? __p.__vector_len(o) : 0; } }
  public Veneris.Communications.Vec4? Pd2(int j) { int o = __p.__offset(14); return o != 0 ? (Veneris.Communications.Vec4?)(new Veneris.Communications.Vec4()).__assign(__p.__vector(o) + j * 16, __p.bb) : null; }
  public int Pd2Length { get { int o = __p.__offset(14); return o != 0 ? __p.__vector_len(o) : 0; } }
  public bool SingleFace { get { int o = __p.__offset(16); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public int FaceId { get { int o = __p.__offset(18); return o != 0 ? __p.bb.GetInt(o + __p.bb_pos) : (int)0; } }

  public static void StartStaticCurvedMesh(FlatBufferBuilder builder) { builder.StartTable(8); }
  public static void AddTransform(FlatBufferBuilder builder, Offset<Veneris.Communications.Matrix4x4> transformOffset) { builder.AddStruct(0, transformOffset.Value, 0); }
  public static void AddVertices(FlatBufferBuilder builder, VectorOffset verticesOffset) { builder.AddOffset(1, verticesOffset.Value, 0); }
  public static void StartVerticesVector(FlatBufferBuilder builder, int numElems) { builder.StartVector(12, numElems, 4); }
  public static void AddIndexes(FlatBufferBuilder builder, VectorOffset indexesOffset) { builder.AddOffset(2, indexesOffset.Value, 0); }
  public static VectorOffset CreateIndexesVector(FlatBufferBuilder builder, int[] data) { builder.StartVector(4, data.Length, 4); for (int i = data.Length - 1; i >= 0; i--) builder.AddInt(data[i]); return builder.EndVector(); }
  public static VectorOffset CreateIndexesVectorBlock(FlatBufferBuilder builder, int[] data) { builder.StartVector(4, data.Length, 4); builder.Add(data); return builder.EndVector(); }
  public static void StartIndexesVector(FlatBufferBuilder builder, int numElems) { builder.StartVector(4, numElems, 4); }
  public static void AddMaterial(FlatBufferBuilder builder, Offset<Veneris.Communications.MaterialEMP> materialOffset) { builder.AddStruct(3, materialOffset.Value, 0); }
  public static void AddPd1(FlatBufferBuilder builder, VectorOffset pd1Offset) { builder.AddOffset(4, pd1Offset.Value, 0); }
  public static void StartPd1Vector(FlatBufferBuilder builder, int numElems) { builder.StartVector(16, numElems, 4); }
  public static void AddPd2(FlatBufferBuilder builder, VectorOffset pd2Offset) { builder.AddOffset(5, pd2Offset.Value, 0); }
  public static void StartPd2Vector(FlatBufferBuilder builder, int numElems) { builder.StartVector(16, numElems, 4); }
  public static void AddSingleFace(FlatBufferBuilder builder, bool singleFace) { builder.AddBool(6, singleFace, false); }
  public static void AddFaceId(FlatBufferBuilder builder, int faceId) { builder.AddInt(7, faceId, 0); }
  public static Offset<Veneris.Communications.StaticCurvedMesh> EndStaticCurvedMesh(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.StaticCurvedMesh>(o);
  }
  public static void FinishStaticCurvedMeshBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.StaticCurvedMesh> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedStaticCurvedMeshBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.StaticCurvedMesh> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
